import processing.serial.*;
import cc.arduino.*;
Arduino arduino;

PImage bg;
color dunkel=color(100, 100, 100);
color hell = color(200, 200, 200);
color r1=dunkel;
color r2=dunkel;
color r3=dunkel;
color r4=dunkel;
float x, xd, xd2, xdd2, xddd2, xd3, xd4 ;
float y, yd, yd2, ydd2, yddd2, yd3, yd4;
int r;
float theta, theta2;
int ox;
int oy;



void setup() {
  size(400, 400);
  frameRate(30);
  bg = loadImage("Prothese1.bmp");
  println(Arduino.list());
  arduino = new Arduino(this, Arduino.list()[0], 57600);
  //Arduinoausgänge sind Steckboardeingänge
  arduino.pinMode(13, Arduino.OUTPUT);//sensor 4
  arduino.pinMode(12, Arduino.OUTPUT);//sensor 3
  arduino.pinMode(11, Arduino.OUTPUT);//sensor 2
  arduino.pinMode(10, Arduino.OUTPUT);//sensor 1
  //Arduinoeingänge sind Steckplatinenausgänge
  arduino.pinMode(6, Arduino.INPUT);//Daumen zu
  arduino.pinMode(7, Arduino.INPUT);//Daumen auf
  arduino.pinMode(8, Arduino.INPUT);//Ellenbogen beugen
  arduino.pinMode(9, Arduino.INPUT);//Ellenbogen strecken
  for (int i=0;i<4;i++) {
    arduino.digitalWrite(i+10, Arduino.LOW);
  };
  r=120;
  theta=1.6;
  //für Daumen
  theta2=0;
  //neuer Ursprung am Ellenbogen
  ox=293;
  oy=140;
  smooth();
}

void draw() {
  background(bg);
  translate(ox, oy);
  //buttons
  strokeWeight(1);
  fill(r1);
  rect(10-ox, 10-oy, 30, 30);
  fill(r2);
  rect(50-ox, 10-oy, 30, 30);
  fill(r3);
  rect(90-ox, 10-oy, 30, 30);
  fill(r4);
  rect(130-ox, 10-oy, 30, 30);
  //prothese unterarm
  strokeWeight(40);
  stroke(hell);
  x = r * cos(theta);
  y = r * sin(theta);
  line(0, 0, x, y);
  //Hand
  strokeWeight(15);
  stroke(dunkel);
  xd = (r+20) * cos(theta);
  yd = (r+20) * sin(theta);
  xdd2 = (r+35) * cos(theta-0.05);
  ydd2 = (r+35) * sin(theta-0.05);
  xddd2 = (r+40) * cos(theta-0.05);
  yddd2 = (r+40) * sin(theta-0.05);
  xd2 = (r+50) * cos(theta);
  yd2 = (r+50) * sin(theta);
  line(xd, yd, xdd2, ydd2);
  strokeWeight(10); 
  line(xddd2, yddd2, xd2, yd2);
  //Daumen
  strokeWeight(10);
  stroke(dunkel);
  xd3 = (r+20) * cos(theta+0.05);
  yd3 = (r+20) * sin(theta+0.05);
  xd4 = (r+45) * cos(theta+0.15-theta2);
  yd4 = (r+45) * sin(theta+0.15-theta2);
  line(xd3, yd3, xd4, yd4);
  if (arduino.digitalRead(8) == Arduino.HIGH) {
    //Ellenbogen beugen
    if (theta<3.5) {
      theta=theta+0.05;
    };
  };
  if (arduino.digitalRead(9) == Arduino.HIGH) {
    //Ellenbogen strecken
    if (theta>1.5) {
      theta=theta-0.05;
    };
  };  
  if (arduino.digitalRead(6) == Arduino.HIGH) {
    //Daumen schließen
    if (theta2<0.15) {
      theta2=theta2+0.01;
    };
  };
  if (arduino.digitalRead(7) == Arduino.HIGH) {
    //Daumen öffnen
    if (theta2>0) {
      theta2=theta2-0.01;
    };
  };
}
void mousePressed()
{
  //Sensor 1
  if (mouseX >= 10 && mouseX <= 40 && 
    mouseY >= 10 && mouseY <= 40) {
    if (r1==dunkel) {
      r1=hell;
      arduino.digitalWrite(10, Arduino.HIGH);
    }
    else {
      r1=dunkel;
      arduino.digitalWrite(10, Arduino.LOW);
    };
  }
  ;
  //Sensor 2
  if (mouseX >= 50 && mouseX <= 80 && 
    mouseY >= 10 && mouseY <= 40) {

    if (r2==dunkel) {
      r2=hell;
      arduino.digitalWrite(11, Arduino.HIGH);
    }
    else {
      r2=dunkel;
      arduino.digitalWrite(11, Arduino.LOW);
    };
  }
  ;
  //Sensor 3
  if (mouseX >= 90 && mouseX <= 120 && 
    mouseY >= 10 && mouseY <= 40) {
    if (r3==dunkel) {
      r3=hell;
      arduino.digitalWrite(12, Arduino.HIGH);
    }
    else {
      r3=dunkel;
      arduino.digitalWrite(12, Arduino.LOW);
    };
  }
  ;
  //Sensor 4
  if (mouseX >= 130 && mouseX <= 160 && 
    mouseY >= 10 && mouseY <= 40) {
    if (r4==dunkel) {
      r4=hell;
      arduino.digitalWrite(13, Arduino.HIGH);
    }
    else {
      r4=dunkel;
      arduino.digitalWrite(13, Arduino.LOW);
    };
  };
}

